module.exports = {
  extends: ['eslint-config-trainiac-base'].map(require.resolve),
  parserOptions: {
    ecmaFeatures: {
      jsx: true
    }
  },
  settings: {
    react: {
      pragma: 'React',
      version: '^15.3.2'
    }
  },
  env: {
    browser: true
  },
  plugins: [
    'react'
  ],
  rules: {

    //JSX
    'react/jsx-boolean-value': 'off',

    // React
    'react/no-multi-comp': 'warn',
    'react/no-unused-prop-types': 'warn',
    'react/prefer-stateless-function': 'warn',
    'react/self-closing-comp': 'warn',

    // JSX
    'react/jsx-closing-bracket-location': 'warn',
    'react/jsx-curly-spacing': ['warn', 'never'],
    'react/jsx-equals-spacing': ['warn', 'never'],
    'react/jsx-first-prop-new-line': ['warn', 'multiline'],
    'react/jsx-handler-names': 'warn',
    'react/jsx-indent': ['warn', 2],
    'react/jsx-indent-props': ['warn', 2],
    'react/jsx-max-props-per-line': ['warn', { 'maximum': 2 }],
    'react/jsx-no-bind': 'warn',
    'react/jsx-no-comment-textnodes': 'warn',
    'react/jsx-no-target-blank': 'warn',
    'react/jsx-pascal-case': 'warn',
    'react/jsx-space-before-closing': ['warn', 'never'],
    'react/jsx-uses-vars': 'warn',
    'react/jsx-wrap-multilines': 'warn',

    // React
    'react/no-children-prop': 'error',
    'react/no-danger-with-children': 'error',
    'react/no-danger': 'error',
    'react/no-deprecated': 'error',
    'react/no-did-mount-set-state': 'error',
    'react/no-did-update-set-state': 'error',
    'react/no-direct-mutation-state': 'error',
    'react/no-find-dom-node': 'error',
    'react/no-is-mounted': 'error',
    'react/no-render-return-value': 'error',
    'react/no-string-refs': 'error',
    'react/no-unescaped-entities': 'error',
    'react/no-unknown-property': 'error',
    'react/prefer-es6-class': 'error',
    'react/prop-types': 'error',
    'react/react-in-jsx-scope': 'error',
    'react/require-render-return': 'error',
    'react/style-prop-object': 'error',

    // JSX
    'react/jsx-key': 'error',
    'react/jsx-no-duplicate-props': 'error',
    'react/jsx-no-undef': 'error',
    'react/jsx-uses-react': 'error'
  }
}

